"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useListener = void 0;
var tslib_1 = require("tslib");
var react_1 = require("react");
var Controller_1 = tslib_1.__importDefault(require("./Controller"));
var useController_1 = require("./useController");
var utils_1 = require("./utils");
function useListener(source, listener, listenWhen) {
    var controller = (0, useController_1.useControllerInternal)(source);
    var stateRef = (0, react_1.useRef)(controller.state);
    var callback = (0, react_1.useCallback)(function (newState) { return listener(newState); }, [listener]);
    (0, react_1.useEffect)(function () {
        var subcription = controller.observable.subscribe(function (newState) {
            var _a;
            var state = stateRef.current;
            if ((0, utils_1.isEquals)(state, newState)) {
                return;
            }
            if ((_a = listenWhen === null || listenWhen === void 0 ? void 0 : listenWhen(state, newState)) !== null && _a !== void 0 ? _a : true) {
                callback(newState);
            }
            stateRef.current = newState;
        });
        return function () {
            subcription.unsubscribe();
        };
    }, [callback, controller.observable, listenWhen]);
    if (source instanceof Controller_1.default) {
        return;
    }
    return controller;
}
exports.useListener = useListener;
//# sourceMappingURL=useListener.js.map