import { Fragment as _Fragment, jsx as _jsx } from "react/jsx-runtime";
import { createContext } from 'react';
import { useBuilder } from './useBuilder';
import { useListener } from './useListener';
import { useController } from './useController';
import { useAutoDispose } from './useAutoDispose';
function createControllerContext() {
    var reactContext = createContext(undefined);
    var controllerContext = {
        Provider: function () { return _jsx(_Fragment, {}); },
        Builder: function () { return _jsx(_Fragment, {}); },
        Listener: function () { return _jsx(_Fragment, {}); },
        _context: reactContext,
    };
    var ControllerProvider = function (_a) {
        var create = _a.create, children = _a.children;
        var controller = useAutoDispose(function () { return create(); });
        return _jsx(reactContext.Provider, { value: controller, children: children });
    };
    controllerContext.Provider = ControllerProvider;
    var Builder = function (_a) {
        var builder = _a.builder, buildWhen = _a.buildWhen;
        var _b = useBuilder(controllerContext, buildWhen), state = _b[0], controller = _b[1];
        return builder(state, controller);
    };
    controllerContext.Builder = Builder;
    var Listener = function (_a) {
        var listener = _a.listener, listenWhen = _a.listenWhen, children = _a.children;
        var controller = useController(controllerContext);
        useListener(controllerContext, function (state) { return listener(state, controller); }, listenWhen);
        return _jsx(_Fragment, { children: children });
    };
    controllerContext.Listener = Listener;
    return controllerContext;
}
function createLinkedControllerContext() {
    return createControllerContext();
}
export { createControllerContext, createLinkedControllerContext };
//# sourceMappingURL=ControllerContext.js.map