import { useCallback, useEffect, useRef } from 'react';
import Controller from './Controller';
import { useControllerInternal } from './useController';
import { isEquals } from './utils';
function useListener(source, listener, listenWhen) {
    var controller = useControllerInternal(source);
    var stateRef = useRef(controller.state);
    var callback = useCallback(function (newState) { return listener(newState); }, [listener]);
    useEffect(function () {
        var subcription = controller.observable.subscribe(function (newState) {
            var _a;
            var state = stateRef.current;
            if (isEquals(state, newState)) {
                return;
            }
            if ((_a = listenWhen === null || listenWhen === void 0 ? void 0 : listenWhen(state, newState)) !== null && _a !== void 0 ? _a : true) {
                callback(newState);
            }
            stateRef.current = newState;
        });
        return function () {
            subcription.unsubscribe();
        };
    }, [callback, controller.observable, listenWhen]);
    if (source instanceof Controller) {
        return;
    }
    return controller;
}
export { useListener };
//# sourceMappingURL=useListener.js.map