import Controller from './Controller';
import { useBuilder } from './useBuilder';
import { useControllerInternal } from './useController';
function useSelector(source, stateSelector) {
    var controller = useControllerInternal(source);
    var buildWhen = function (prev, curr) { return stateSelector(prev) !== stateSelector(curr); };
    var state = useBuilder(controller, buildWhen);
    if (source instanceof Controller) {
        return stateSelector(state);
    }
    return [stateSelector(state), controller];
}
export { useSelector };
//# sourceMappingURL=useSelector.js.map